package eu.clarin.cmdi.oai.harvester;

import java.net.URI;

import eu.clarin.cmdi.oai.harvester.ext.DescriptionParser;

public interface Harvester {

    public void registerDescriptionParser(DescriptionParser parser)
            throws HarvesterException;

    public HarvestJob createJob(URI repositoryURI, HarvestHandler handler)
            throws HarvesterException;

    public HarvestJob createJob(URI repositoryURI)
            throws HarvesterException;

    public HarvestJob createJob(String repositoryURI, HarvestHandler handler)
            throws HarvesterException;

    public HarvestJob createJob(String repositoryURI)
            throws HarvesterException;

    public HarvestJob findJob(long id)
            throws HarvesterException;

    public HarvestJob cancelJob(long id)
            throws HarvesterException;

    public void shutdown();

    public int getMaxNetworkRetryCount();
    
    public void setMaxNetworkRetryCount(int maxNetworkRetryCount);

} // interface Harvester
