package eu.clarin.cmdi.oai.harvester;
import java.util.Date;
import java.util.List;

public interface Repository {
    public static enum DeletedNotion {
        NO,
        TRANSIENT,
        PERSISTENT
    }

    public static enum Granularity {
        DAYS,
        SECONDS
    }

    public static final int COMPRESSION_METHOD_DEFLATE = 0x01;
    public static final int COMPRESSION_METHOD_GZIP = 0x02;

    public String getRepositoryName();

    public String getBaseURL();

    public String getProtocolVersion();

    public List<String> getAdminEmail();

    public Date getEarliestTimestamp();

    public DeletedNotion getDeletedNotion();

    public Granularity getGranularity();

    public int getCompressionMask();

    public List<Description> getDescriptions();

} // interface Repository
